
//
// npshell.cpp - Plug-in methods called from Netscape.
//

#include <string.h>
#include "..\inc\stdafx.h"
#include "npwindow.h"
#include "nptree.h"


CWinApp	theApp;

//
// NPP_Initialize
//
NPError NPP_Initialize(void)
{
  MessageBox(NULL, "NPP_Initialize","Inside NPP_Initialize",MB_OK);
  
    return NPERR_NO_ERROR;
}


//
// NPP_Shutdown
//
void NPP_Shutdown(void)
{
  MessageBox(NULL, "NPP_Shutdown","Inside NPP_Shutdown",MB_OK);
  
}


//
//	NPP_GetJavaClass - This plug-in does not use the Java Runtime Interface (JRI)
//
jref NPP_GetJavaClass (void)
{
	// If no java is used return NULL.

	return NULL;
}


//
// NPP_New - Create a new plug-in instance.
//
NPError NP_LOADDS NPP_New (NPMIMEType pluginType,
	NPP pInstance,
    uint16 mode,
    int16 argc,
    char* argn[],
    char* argv[],
    NPSavedData* saved)
{   
  MessageBox(NULL, "NPP_New","Inside NPP_New",MB_OK);
  
    if (pInstance == NULL)
        return NPERR_INVALID_INSTANCE_ERROR;

	// Create a new CCpuMon object

	CCpuMon* pCpuMon = new CCpuMon (pInstance);

	// Attach it to the instance structure

	pInstance->pdata = pCpuMon;

	// No window yet

    pCpuMon->pWindow = NULL;

	// Save our plug-in's mode

  //  pCpuMon->mode = mode;       

    return NPERR_NO_ERROR;
}


//
// NPP_Destroy - Destroy our plug-in instance.
//
NPError NP_LOADDS NPP_Destroy (NPP pInstance, NPSavedData** save)
{
  MessageBox(NULL, "NPP_Destroy","Inside NPP_Destroy",MB_OK);
  
    CCpuMon* pCpuMon = (CCpuMon *)pInstance->pdata;

	if (pCpuMon)
	{
		if (pCpuMon->pWindow)
		{
			// Unsubclass the window, clean it up and delete it.

			pCpuMon->pWindow->UnsubclassWindow ();
			pCpuMon->pWindow->CleanupWindow();

			delete pCpuMon->pWindow;
		}

		pCpuMon->Close ();

		delete pCpuMon;
		pInstance->pdata = NULL;
	}
	return NPERR_NO_ERROR;
}
	

//
// NPP_SetWindow - A window was created, resized, or destroyed.
//
NPError NP_LOADDS NPP_SetWindow (NPP pInstance, NPWindow* window)
{    
  MessageBox(NULL, "NPP_SetWindow","Inside NPP_SetWindow",MB_OK);
  
    if (!window)
        return NPERR_GENERIC_ERROR;

    if (!pInstance)
        return NPERR_INVALID_INSTANCE_ERROR;

	// Get instance data

    CCpuMon* pCpuMon = (CCpuMon *)pInstance->pdata; 

    if (!pCpuMon) 
        return NPERR_GENERIC_ERROR;

	// Spurious entry - just return

    if (!window->window && !pCpuMon->pWindow) 
        return NPERR_NO_ERROR;

	// Window should have been destroyed, but because of a bug in
	// Navigator, we consider this a spurious entry.

    if (!window->window && pCpuMon->pWindow)
        return NPERR_NO_ERROR;

    if (!pCpuMon->pWindow && window->window)    
    {
		// Create our plug-in's window class and
		// subclass it to Navigators.
MessageBox(NULL, "About to subclass","Inside NPP_SetWindow",MB_OK);
  
        pCpuMon->pWindow = new CPluginWindow (pCpuMon);
MessageBox(NULL, "Constructor complete","Inside NPP_SetWindow",MB_OK);
  	
		BOOL rc = pCpuMon->pWindow->SubclassWindow ((HWND)window->window);

		// Init window and give the object a pointer to
		// the cpu monitor object.

		pCpuMon->pWindow->InitWindow ();
    }
    
    // Redraw the window.

    pCpuMon->pWindow->InvalidateRect (NULL);
    pCpuMon->pWindow->UpdateWindow();
        
    return NPERR_NO_ERROR;
}


//
// NPP_NewStream - A new stream was created.
//
NPError NP_LOADDS NPP_NewStream(NPP pInstance,
	NPMIMEType type,
	NPStream* pStream, 
	NPBool seekable,
	uint16* stype)
{
  MessageBox(NULL, "NPP_NewStream","Inside NPP_NewStream",MB_OK);
  
    if(!pInstance)
        return NPERR_INVALID_INSTANCE_ERROR;

	CCpuMon* pCpuMon = (CCpuMon *)pInstance->pdata;

	*stype = NP_ASFILE;

	if (pCpuMon)
		pCpuMon->Open (pStream);

    return NPERR_NO_ERROR;
}


//
// NPP_WriteReady - Returns amount of data we can handle for the next NPP_Write
//                             
int32 NP_LOADDS	NPP_WriteReady (NPP pInstance, NPStream *stream)
{
  MessageBox(NULL, "NPP_WriteReady","Inside NPP_WriteReady",MB_OK);
  
	return 0x0FFFFFFF;
}


//
// NPP_Write 
// 
int32 NP_LOADDS NPP_Write (NPP pInstance, NPStream *stream, int32 offset, int32 len, void *buffer)
{   
  MessageBox(NULL, "NPP_Write","Inside NPP_Write",MB_OK);
  
    return len;
}


//
// NPP_StreamAsFile 
// 
void NP_LOADDS NPP_StreamAsFile (NPP pInstance, NPStream* stream, const char* fname)
{
  MessageBox(NULL, "NPP_StreamAsFile","Inside NPP_StreamAsFile",MB_OK);
  
	CCpuMon* pCpuMon = (CCpuMon *)pInstance->pdata;
 	
 	if (pCpuMon)   
    	pCpuMon->GotFileName (fname);
}
 

//
// NPP_DestroyStream 
// 
NPError NP_LOADDS NPP_DestroyStream (NPP pInstance, NPStream *stream, NPError reason)
{
  MessageBox(NULL, "NPP_DestroyStream","Inside NPP_DestroyStream",MB_OK);
  
 	CCpuMon* pCpuMon = (CCpuMon *)pInstance->pdata;
 	
 	if (pCpuMon)   
    	pCpuMon->EndOfStream ();
	       
    return NPERR_NO_ERROR;
}


//
// NPP_Print - This plug-in does not print.
//
void NP_LOADDS NPP_Print (NPP pInstance, NPPrint* printInfo)
{
}
	




